# Kurssin materiaalit

| *Aihe* | *Nimi & Linkki* | *Muuta* |
| :--------: | :-------: | :-----: |
| Ohjelmistotuotanto | [Ohjelmistotuotannon käytännöt,- Tommi Mikkonen - Ilkka Haikala ](http://janet.amkit.fi/cgi-bin/Pwebrecon.cgi?SC=Title&SEQ=20131219103325&PID=xq_HMVSIFeT2k23O-DABbO4oj&SA=Ohjelmistotuotannon+k%C3%A4yt%C3%A4nn%C3%B6t+/) | <img alt="" height="90"  width="60"  src="https://s2.adlibris.com/images/9150354/ohjelmistotuotannon-kaytannot.jpg" /> |
| Kirja | [Ohjelmistotuotanto, Ilkka Haikala - Jukka Märijärvi](https://www.booky.fi/tuote/ilkka_haikala/ohjelmistotuotanto/9789521408502) | <img alt="" height="90"  width="60" src="https://www.booky.fi/image.php?id=9789521408502&size=small" /> |
| Palvelumuotoilu | [Palvelumuotoilu, Juha Tuulaniemi 2011](https://www.facebook.com/palvelumuotoilu) | <img alt="" height="90"  width="60"  src="https://www.talentumshop.fi/media/catalog/product/cache/1/image/380x505/26fe0c86a0e9dbe34ab5599cb60da8a3/9/7/978-952-14-1551-7_Palvelumuotoilu_3d.jpg_1.jpg" /> |
| Ohjelmistotestaus | [Ohjelmistotestaus](http://ekirjasto.kirjastot.fi/en/ekirjat/ohjelmistotestauksen-kasikirja) | <img alt="" height="90"  width="60"  src="http://www.ellibs.com/sites/default/files/imagecache/product/bookcover_978-952-5912-99-9.jpg" />  |
| Mallinnus | [UML Distilled - Third Edition, Martin Fowler](http://martinfowler.com/books/uml.html) | <img alt="" height="90"  width="60"  src="http://martinfowler.com/books/umldist.jpg" width="200" /> |



# Linkkejä liittyen aiheisiin..


## Palvelumuotoilu (Service Design)

Linkkejä joita kannattaa tutkia....

* [Forge Service Design Material](https://gitlab.labranet.jamk.fi/forgeservicelab/forge-sdt)
* [Palvelumuotoilun työkalupakki](http://sdt.fi)
* [Palvelumuotoilua suomeksi](http://palvelukehitys.wikispaces.com/)
* [Journey Map](http://www.heartofthecustomer.com/customer-experience-journey-map-the-top-10-requirements/)
* [Palvelumuotoilu.fi](http://palvelumuotoilu.fi/)
* [Yritys esimerkki: Palmu](http://palmu.fi/)
* http://www.slideshare.net/samietti/servicedesign-methods
* [Service Design Tools](http://www.servicedesigntools.org/)
* [Service Design Toolkit](http://www.servicedesigntoolkit.org/)
* [Nordström innovation labs](https://www.youtube.com/watch?v=szr0ezLyQHY)


## Use Case

* [Use Case 2.0](https://www.ivarjacobson.com/sites/default/files/field_iji_file/article/use-case_2_0_jan11.pdf)

## Dokumentointi

Dokumenttipohjia 

* [HYäksytty !ToimintaTapa HYTT](http://www.cs.tut.fi/~hytt/?nk_no=2&nk_id=148)
* [TUT dokumenttipohjat](http://www.cs.tut.fi/ohj/dokumenttipohjat/)




## Vaatimusten kerääminen ja hallinta


* [Tube: Requirement Gathering](http://www.youtube.com/watch?v=rSwVZJT9j1c)
* [Tube: User Storys as Requirements](http://www.youtube.com/watch?v=6q5-cVeNjCE)
* [User Story](http://searchsoftwarequality.techtarget.com/definition/user-story)
* [Tube: Requirement Gathering](http://www.youtube.com/watch?v=txK1225LlVM)
* [Tube: "True" story from field](http://www.youtube.com/watch?v=l_GTTyE9i9Y)
* [Tube: Agile Requirement Gathering](http://www.youtube.com/watch?v=iUIWLNiGYEk)
*  http://cse.aalto.fi/en/research/empirical_software_engineering/product_requirements/
*  http://fi.wikipedia.org/wiki/Ohjelmiston_vaatimusm%C3%A4%C3%A4rittely 
*  http://en.wikipedia.org/wiki/Software_requirements_specification
*  https://jyx.jyu.fi/dspace/handle/123456789/38590
*  http://fi.wikipedia.org/wiki/Ohjelmiston_vaatimusm%C3%A4%C3%A4rittely
*  http://www.tieke.fi/pages/viewpage.action?pageId=3441242
*  http://csis.pace.edu/~marchese/CS775/Requirements%20Specification%20Template.doc
*  http://home.adelphi.edu/~siegfried/cs480/ReqsDoc.pdf

## UML -mallinnus


* [UML tutoriaali kokoelma](http://www.jeckle.de/umllinks.htm#tutorials)
* http://fi.wikipedia.org/wiki/UML-mallinnus
* [UML tutorials](http://www.tutorialspoint.com/uml/index.htm)
* [DIA and UML Sequence Diagram](http://www.youtube.com/watch?v=8gSCrm-Kubo)
* [DIA and UML Use Case](http://www.youtube.com/watch?v=iXcZRZRwxEg)
* [MIT Courses for USE CASE](http://ocw.mit.edu/courses/architecture/4-297-special-problems-in-architecture-studies-fall-2000/labs/UML1.pdf) |
* [UML Class Diagrams](http://www.youtube.com/watch?v=OOpiaIcyz30)
* [UML Design Patterns](http://en.wikipedia.org/wiki/Architectural_pattern_(computer_science))
* [UML Class Diagrams](https://en.wikipedia.org/wiki/Unified_Modeling_Language#Diagrams)




## MockUp & Graafinen suunnittelu:

* [Adobe Color Wheel](https://color.adobe.com/create/color-wheel/)
* [Adobe Color CC](https://color.adobe.com/explore/newest/)
* [ Stylify Me](http://stylifyme.com/?stylify=contriboard.n4sjamk.org)
* [Pure CSS](http://purecss.io/)
* [Color Lovers](http://www.colourlovers.com/palettes)

## Prototyypit ja käytettävyys

* [Esimerkkivideo](https://www.youtube.com/watch?v=szr0ezLyQHY) pikaisesta UX-kehittäjien sekä devaajien viikon pituisesta iphone-sovelluskehityksestä
* Heli Sutisen [opinnäytetyö](https://www.theseus.fi/handle/10024/86173) mockup-työkaluista
* [Lean UX blogipostaus](https://www.smashingmagazine.com/2011/03/lean-ux-getting-out-of-the-deliverables-business/)
* [Tube: | But How ?](http://www.youtube.com/watch?v=7OSkB4BCx00)


Tähän tulee lisää...



## Testaus 

Työvälineitä

* [Testing Tools](http://en.wikipedia.org/wiki/Category:Software_testing_tools)
* [Test Management Tools](https://en.wikipedia.org/wiki/Test_management_tools)

## Testaukseen liittyvät järjestöt & yhteisöt

*  [ISTQB Sanasto](http://www.fistb.fi/sites/fistb.ttlry.mearra.com/files/istqb_sanasto.pdf) 
*  [ISTQB](http://www.istqb.org/)
*  [TestausOSY](http://testausosy.fi/)
*  [TestausOSY Linkedin group](http://www.linkedin.com/groups/TestausOSY-FAST-1812274/about)
*  [Stickyminds](http://www.stickyminds.com/)
*  [Finnish Software Testing Board (FiSTB)](http://www.fistb.fi/#!)


##  Testaus

* [Master Test Plan](http://qablog.practitest.com/2008/03/master-test-plan-the-strategic-side-of-testing/)
* [You are not done yet!](http://www.thebraidytester.com/downloads/YouAreNotDoneYet.pdf)
* [Ohjelmistotestaus.fi](http://ohjelmistotestaus.fi/)
* [What is a good Test](http://www.kaner.com/pdfs/GoodTest.pdf)
* [Unit Testing](http://stackoverflow.com/questions/67299/is-unit-testing-worth-the-effort)
* [How to Write Clean, Testable Code, Misco Hevery](https://www.youtube.com/watch?v=XcT4yYu_TTs)

## Kiinnostavia henkilöitä 

*  [Maaret Pyhäjärvi](http://visible-quality.blogspot.fi/ https://www.linkedin.com/in/maaret)
*  [Cem Kaner](http://kaner.com/ | http://www.youtube.com/watch?v=2g4EqP57l7I&list=PL1C98945CECC21E22)
*  [James Bach](http://www.satisfice.com/ | http://www.youtube.com/watch?v=3FTwaojNkXw)
*  [Janet Gregory](http://janetgregory.ca/)
*  [Lisa Crispin](http://www.youtube.com/watch?v=tbOKe9WpnRw)
*  [Elisabeth Hendrickson](http://www.youtube.com/watch?v=bqrOnIECCSg)
*  [Matt Heusser](http://www.youtube.com/watch?v=xkqqwwwugdY&feature=youtu.be)
*  [Michael Bolton](http://www.youtube.com/watch?v=VNfPwD9u9Bk)
*  [Jerry Weinberg](http://www.softwaretestpro.com/Item/4920/)
*  [Hmm..](http://www.youtube.com/watch?v=XcT4yYu_TTs)

## Standardeja

Linkit tulossa... (googleta)

  * [DO-178b DO-178B:1992. Software Considerations in Airborne Systems and Equipment Certification,
Requirements and Technical Concepts for Aviation (RTCA SC167)]()
  * [IEEE 610 IEEE 610.12:1990. Standard Glossary of Software Engineering Terminology.]()
  * [IEEE 829 IEEE 829:1998. Standard for Software Test Documentation](http://ieeexplore.ieee.org/xpl/mostRecentIssue.jsp?reload=true&punumber=4578271)
  * [IEEE 1008 IEEE 1008:1993. Standard for Software Unit Testing](http://ieeexplore.ieee.org/xpl/mostRecentIssue.jsp?punumber=2599)
  * [IEEE 1028 IEEE 1028:1997. Standard for Software Reviews and Audits]()
  * [IEEE 1044 IEEE 1044:1993. Standard Classification for Software Anomalies]()
  * [IEEE 1219 IEEE 1219:1998. Software Maintenance]()
  * [ISO 2382/1 ISO/IEC 2382-1:1993. Data processing - Vocabulary - Part 1: Fundamental terms]()
  * [ISO 8402 ISO 8402: 1994. Quality Management and Quality Assurance Vocabulary]()
  * [ISO 9000 ISO 9000:2005. Quality Management Systems – Fundamentals and Vocabulary]()
  * [ISO 9126 ISO/IEC 9126-1:2001. Software Engineering – Software Product Quality – Part 1: Quality
characteristics and sub-characteristics ]()
  * [ISO 12207 ISO/IEC 12207:1995. Information Technology – Software Lifecycle Processes ]()
  * [ISO 14598 ISO/IEC 14598-1:1999. Information Technology – Software Product Evaluation - Part 1:
General Overview]()
  * [ISO 15504 ISO/IEC 15504-9: 1998. Information Technology – Software Process Assessment – Part
9: Vocabulary]()

## Palvelutuotanto  /ITIL


* [ITIL ?](https://fi.wikipedia.org/wiki/ITIL)
* [Sanasto](https://www.exin.com/assets/exin/frameworks/108/glossaries/finnish_glossary_v1.0_201404.pdf)



# Työpaja 

* [Kanban-pizza-game](http://www.agile42.com/en/training/kanban-pizza-game/)



# Työvälineitä


## GitHub

* [Tube: Helloworld github](https://guides.gitlab.labranet.jamk.fi/activities/hello-world/)

## Suunnitteluvälineitä (Design Tools)

*  [Pencil Project opetus video](http://www.youtube.com/watch?v=tc4c5FX1EHU)
*  [DIA diagram editor](http://www.youtube.com/watch?v=FVsvsrzxmnI)
*  [Mind Mapping](http://www.youtube.com/watch?v=wLWV0XN7K1g)
*  [Mind Mapping](http://www.youtube.com/watch?v=mRFn1U3jvCw)
*  [Mind mapping requirements](http://www.youtube.com/watch?v=kOUOH6DNzAI)
*  [FreeMind tool and](http://www.youtube.com/watch?v=grut_2cardM)
*  [Service Design Tools](http://www.servicedesigntools.org/)

## Järjestelmäarkkitehtuuri

Tulossa...

Micro Service Architecture | https://www.youtube.com/watch?v=PFQnNFe27kU |

## Kokonaisarkkitehtuuri



## Testaus & Muut jännät jutskat!

* [Open Source Security Testing Methodology Manual OSSTMM](http://www.isecom.org/research/)
*  [Ollin tuumailut](http://ollintuumailut.blogspot.fi/2014/04/ohjelmistotestaus-osa.html)
*  [Testaus Blogi](http://avustaja.blogspot.fi/ |
*  [Web Designer Nightmare](http://www.youtube.com/watch?v=CfxTc7_1UVE)
*  [IteWiki](http://www.itewiki.fi)
*  [Vitsi](https://www.youtube.com/watch?v=lXNu0VBVCUc]

## Projektin hallinta linkkeja ja toimijoita

  * Project Management Institute (PMI): http://www.pmi.org/
  * International Project Management Association (IPMA): http://www.ipma.ch/
  * Software Engineering Institute (SEI): http://www.sei.cmu.edu/
  * Association for Project Management: http://www.apm.org.uk/
  * IEEE Software Engineering Group: http://www.computer.org/
  * Suomessa: Projektiyhdistys ry http://www.pry.fi/
  * Työkaluja: http://www.pm-software-tools.com/
  * Kurssi: http://www.projectreference.com/

## Projektisuunnitelma

  * http://www.tekes.fi/rahoitus/rahoituksen-hakeminen/projektisuunnitelma/





Usabilihttps://www.youtube.com/watch?v=zbL4LwmWAy0ty/Käytettävyys
  
  * http://worldusabilitydayjkl.fi/index.en.html


### Esimerkkejä yrityselämästä:
 
 * https://data.controla.fi/massainfo/
 * http://www.meteoriitti.com/Mita-teemme/Palvelut/Strateginen-suunnittelu/Vaatimusmaarittely/ 
 * http://www.sofokus.com/tekninen-vaatimusmaarittely/


# Tiimi ja sen kehittäminen

  * http://esseepankki.tiimiakatemia.fi/tiimit-avain-uuden-luomiseen-7/
  * https://www.theseus.fi/bitstream/handle/10024/67437/Tapola_Heini.pdf?sequence=1

# Työkalut

## GitHub

  * https://guides.gitlab.labranet.jamk.fi/features/mastering-markdown/
  * http://lifehacker.com/5983680/how-the-heck-do-i-use-github
  * http://git-scm.com/book/en/v2

# Mallintaminen & suunnittelu

## UI design tools
  * https://www.ninjamock.com


## Domain Specific Modelling

  * http://en.wikipedia.org/wiki/Domain-specific_modeling

# Prosessit ja toimintatavat

## Water Fall


## Iterative

  * [RUP](http://en.wikipedia.org/wiki/Rational_Unified_Process)
  * [Open Process Framework](http://www.opfro.org/)
   
## Agile 

  * http://searchsoftwarequality.techtarget.com/definition/user-story
  * http://www.mountaingoatsoftware.com/agile/scrum
  * Scrum http://scrumreferencecard.com/ScrumReferenceCard.pdf 
  * http://fi.wikipedia.org/wiki/Scrum
  * [User Storys](http://en.wikipedia.org/wiki/User_story)
  * [Job Storys](http://blog.intercom.io/using-job-stories-design-features-ui-ux/)

## LEAN

* [LEAN sanasto](http://leaniksi.fi/lean-sanasto/)
* [Six Sigma](http://www.sixsigma.fi/fi/lean/) 
* [5S](https://fi.wikipedia.org/wiki/5S)
* [Lean Primer](http://www.leanprimer.com/downloads/lean_primer.pdf)
* [](https://www.youtube.com/watch?v=zbL4LwmWAy0)
* http://en.wikipedia.org/wiki/Lean_manufacturing
* http://fi.wikipedia.org/wiki/Kanban
* http://fi.wikipedia.org/wiki/Lean
* http://www.lean.org/WhatsLean/History.cfm

LEAN UX

  * http://www.smashingmagazine.com/2014/01/08/lean-ux-manifesto-principle-driven-design/

## LEAN Startup
* [Minimum Viable Product (MVP)](http://en.wikipedia.org/wiki/Minimum_viable_product)###


## Games


* http://www.leansimulations.org/